/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <stdlib.h>
#include "<T>.defs"
#include "<T>Stack.h"


void make<T>Stack(<T>Stack* st, int size)
{
    if(size <= 0)
    {
	fprintf(stderr, "<T>Stack: Invalid stack size:%d\n", size);
	exit(1);
    }

    if((st->elem = (<T> *)xcalloc(size, sizeof(<T>))) == NULL)
    {
	fprintf(stderr, "<T>Stack: Can't allocate a memory.\n");
	exit(1);
    }
    st->ptr = 0;
    st->size = size;
}

void delete<T>Stack(<T>Stack* st)
{
    xfree(st->elem);
}

void resize<T>Stack(<T>Stack* st, int size)
{
    if(size <= 0)
    {
	fprintf(stderr, "<T>Stack: Invalid stack resize:%d\n", size);
	exit(1);
    }

    if((st->elem = (<T> *)xrealloc(st->elem, sizeof(<T>) * size)) == NULL)
    {
	fprintf(stderr, "<T>Stack: Can't reallocate a memory.\n");
	exit(1);
    }

    st->size = size;
}

void empty<T>Stack(<T>Stack* st)
{
    st->ptr = 0;
}

void push<T>Stack(<T>Stack* st, <T> value)
{
    if(st->ptr == st->size)
	resize<T>Stack(st, st->size * 2);
    st->elem[st->ptr++] = value;
}

<T> top<T>Stack(<T>Stack* st)
{
    if(isempty<T>Stack(st))
    {
	fprintf(stderr, "<T>Stack: Attempted top<T>Stack() for empty stack.\n");
	exit(1);
    }

    return st->elem[st->ptr - 1];
}

<T> pop<T>Stack(<T>Stack* st)
{
    if(isempty<T>Stack(st))
    {
	fprintf(stderr, "<T>Stack: Attempted pop<T>Stack() for empty stack.\n");
	exit(1);
    }

    return st->elem[--st->ptr];
}
