/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___BUILTIN_H_
#define ___BUILTIN_H_

#define STACK(x) (memstack + qh_argstart + (x - 1))

void write_fname_and_lineno(QHProgTraceInfo* info);

void invalid_argument(QHObj* x);

void qh_copy_clone_object(QHObj* target, const QHObj* src);
Bool qh_equal_object(const QHObj* obj1, const QHObj* obj2);
void qh_call_extern_function(MemFunction* f, int argc, QHObj* argv, QHObj*ret);
void qh_vla_bind_proc(long* narg_buff);
/* Specified number of arguments: *narg_buff
 * This variable must be constant.
 */

int sizeof_qhtype(int type);

extern QHObj* memstack;
extern int memstack_size;
extern QHObj null_qhobj;

extern Bool OK_DO_garbage_collecting;
/* if it's False, the garbage-collection isn't work. */

int sizeof_qhtype(int type);
/* query the object size */

int cast_to_int(const QHObj* x);
/* cast to int */

double cast_to_real(const QHObj* x);
/* cast to real */

XComplex cast_to_complex(const QHObj* x);
/* cast to complex */

char* cast_to_string(const QHObj* x);
/* cast to string */

extern int Q_FMT_INT, Q_FMT_REAL, Q_FMT_COMPLEX, Q_FMT_STRING;
extern int Q_ARGC;
extern int Q_NULL;
extern int Q_GEVENT_TYPE, Q_GEVENT_VALUE, Q_GPOINTERX, Q_GPOINTERY;
extern int Q_TIME;
extern int Q_GWINDOW_WIDTH,  Q_GWINDOW_HEIGHT;
extern int Q_GWINDOW_PWIDTH, Q_GWINDOW_PHEIGHT;
extern int Q_GCURRENT_SCREEN, Q_GVISUAL_SCREEN;
extern int min_data_addr;
extern int qh_argstart;

#endif /* ___BUILTIN_H_ */
