/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <stdlib.h>
#include "char_ptr.defs"
#include "char_ptrStack.h"


void makechar_ptrStack(char_ptrStack* st, int size)
{
    if(size <= 0)
    {
	fprintf(stderr, "char_ptrStack: Invalid stack size:%d\n", size);
	exit(1);
    }

    if((st->elem = (char_ptr *)xcalloc(size, sizeof(char_ptr))) == NULL)
    {
	fprintf(stderr, "char_ptrStack: Can't allocate a memory.\n");
	exit(1);
    }
    st->ptr = 0;
    st->size = size;
}

void deletechar_ptrStack(char_ptrStack* st)
{
    xfree(st->elem);
}

void resizechar_ptrStack(char_ptrStack* st, int size)
{
    if(size <= 0)
    {
	fprintf(stderr, "char_ptrStack: Invalid stack resize:%d\n", size);
	exit(1);
    }

    if((st->elem = (char_ptr *)xrealloc(st->elem, sizeof(char_ptr) * size)) == NULL)
    {
	fprintf(stderr, "char_ptrStack: Can't reallocate a memory.\n");
	exit(1);
    }

    st->size = size;
}

void emptychar_ptrStack(char_ptrStack* st)
{
    st->ptr = 0;
}

void pushchar_ptrStack(char_ptrStack* st, char_ptr value)
{
    if(st->ptr == st->size)
	resizechar_ptrStack(st, st->size * 2);
    st->elem[st->ptr++] = value;
}

char_ptr topchar_ptrStack(char_ptrStack* st)
{
    if(isemptychar_ptrStack(st))
    {
	fprintf(stderr, "char_ptrStack: Attempted topchar_ptrStack() for empty stack.\n");
	exit(1);
    }

    return st->elem[st->ptr - 1];
}

char_ptr popchar_ptrStack(char_ptrStack* st)
{
    if(isemptychar_ptrStack(st))
    {
	fprintf(stderr, "char_ptrStack: Attempted popchar_ptrStack() for empty stack.\n");
	exit(1);
    }

    return st->elem[--st->ptr];
}
