/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___COMMON_H_
#define ___COMMON_H_


#include "defs.h"
#include "intStack.h"
#include "textpos.h"
#include "qhlex.h"
#include "lex_atomdat.h"
#include "hash.h"
#include "symbol.h"
#include "tree.h"
#include "quadlist.h"
#include "function.h"
#include "compile.h"
#include "error.h"
#include "stmt.h"
#include "newtemp.h"
#include "opstr.h"
#include "genifgoto.h"
#include "char_ptr.defs"
#include "char_ptrStack.h"
#include "defstruct.h"

#ifndef __QHPARSE_H_
#include "qhparse.h"
#endif

#include "isopdefs.h"
#include "xmalloc.h"


extern int prog_argc;
extern char** prog_argv;

extern char temp_buff[];	/* for using temporary string */
void qhexit(int status);

void free_memory_in_compiling_at_once(void); /* call from garbege-collection */

#ifndef atof /* Can be defined in stdlib on linux */
double atof(const char* s);
#endif /* atof */

#if defined(sgi) || defined(__osf__)
#define inline __inline
#elif !defined(__GNUC__)
#define inline
#endif

/* argument flags */
extern Bool compile_flag;
extern Bool trace_mode;
extern Bool print_code_mode;
extern Bool print_garbage_collection;
extern Bool load_default_qh_library;
extern char_ptrStack cpp_arguments;
extern Bool expr_optimazation;
extern Bool Wall_flag;
extern Bool W_uninitialized_variable;
extern Bool W_undeclared_global_variable;
extern Bool W_case_break;
extern Bool W_unused_local_variable;
extern char* display_host_name;
extern Bool qh_prof_mode;
extern Bool verbose_mode;

#endif /* ___COMMON_H_ */
