/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/param.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <limits.h>
#include <float.h>
#include "common.h"
#include "qhobj.h"

#define PARAM_PREFIX	"_QH_PARAM_"
#define DEFPARAM(x) printf("#define " PARAM_PREFIX #x "\t%d\n", x);

char* today(void)
{
    static char buff[BUFSIZ];
    time_t calt;

    calt = time(NULL);
    strftime(buff, BUFSIZ, "%a %b %d %Y", gmtime(&calt));
    return buff;
}

void main(void)
{
    puts("#ifndef ___DEFPARAM_QHL_");
    puts("#define ___DEFPARAM_QHL_\n");

    printf("#define " PARAM_PREFIX "VERSION\t\"%s\"\n", VERSION);
    printf("#define " PARAM_PREFIX "UPDATE\t\"%s\"\n", today());
    printf("#define " PARAM_PREFIX "DBL_MIN\t%.19e\n", DBL_MIN);
    printf("#define " PARAM_PREFIX "DBL_MAX\t%.19e\n", DBL_MAX);

    DEFPARAM(INT_MIN);
    DEFPARAM(INT_MAX);

    DEFPARAM(BUFSIZ);
    DEFPARAM(EOF);

    puts("\n// fopen");
    DEFPARAM(O_RDONLY);
    DEFPARAM(O_WRONLY);
    DEFPARAM(O_RDWR);

    puts("\n// seek");
    DEFPARAM(SEEK_SET);
    DEFPARAM(SEEK_CUR);
    DEFPARAM(SEEK_END);

    puts("\n// event mask");
    DEFPARAM(KeyPressMask);
    DEFPARAM(KeyReleaseMask);
    DEFPARAM(ButtonPressMask);
    DEFPARAM(ButtonReleaseMask);
    DEFPARAM(ButtonMotionMask);

    puts("\n// event type");
    DEFPARAM(KeyPress);
    DEFPARAM(KeyRelease);
    DEFPARAM(ButtonPress);
    DEFPARAM(ButtonRelease);
    DEFPARAM(MotionNotify);

    puts("\n#endif /* ___DEFPARAM_C_ */");

    exit(0);
}
