
/* Copyright 1995 by Masanao Izumo, in the Kanagawa University. */

#ifndef __GEN_FUNCTAB_H__
#define __GEN_FUNCTAB_H__

#define QH_CALL(op, args) (* functab[(op) - FIRST_INSTRUCTION]) args
extern void (*functab[])();
typedef void (* qh_proc_t)();

void qh_first_instruction();
void qh_nop();
void qh_add();
void qh_sub();
void qh_mul();
void qh_div();
void qh_rem();
void qh_atan2();
void qh_rand2();
void qh_complex_op();
void qh_logor();
void qh_logand();
void qh_llshift();
void qh_lrshift();
void qh_alshift();
void qh_arshift();
void qh_pow();
void qh_eq();
void qh_nq();
void qh_le();
void qh_lt();
void qh_ge();
void qh_gt();
void qh_aassign();
void qh_sassign();
void qh_massign();
void qh_dassign();
void qh_rassign();
void qh_assign();
void qh_sin();
void qh_cos();
void qh_tan();
void qh_asin();
void qh_acos();
void qh_atan();
void qh_sinh();
void qh_cosh();
void qh_tanh();
void qh_asinh();
void qh_acosh();
void qh_atanh();
void qh_abs();
void qh_floor();
void qh_ceil();
void qh_exp();
void qh_log();
void qh_log10();
void qh_log2();
void qh_sqrt();
void qh_rand0();
void qh_rand1();
void qh_int_op();
void qh_real_op();
void qh_image_op();
void qh_conjugate();
void qh_arg();
void qh_uminus();
void qh_getlineop();
void qh_commandop();
void qh_addr();
void qh_indir();
void qh_lognot();
void qh_not();
void qh_notnot();
void qh_zero();
void qh_one();
void qh_structof();
void qh_sizeof_op();
void qh_xinc();
void qh_incx();
void qh_xdec();
void qh_decx();
void qh_last_operator();
void qh_ipush();
void qh_ipush2();
void qh_ipush3();
void qh_param2();
void qh_param3();
void qh_call();
void qh_callext();
void qh_funcall();
void qh_ascref();
void qh_ascset();
void qh_aref1();
void qh_aref();
void qh_aaset();
void qh_asset();
void qh_amset();
void qh_adset();
void qh_arset();
void qh_aset();
void qh_axinc();
void qh_aincx();
void qh_axdec();
void qh_adecx();
void qh_aindir();
void qh_param();
void qh_ifgoto();
void qh_ifngoto();
void qh_ifeqgoto();
void qh_ifnqgoto();
void qh_iflegoto();
void qh_ifltgoto();
void qh_ifgegoto();
void qh_ifgtgoto();
void qh_goto();
void qh_list_op();
void qh_stref();
void qh_stset();
void qh_return();
void qh_end();
void qh_write();
void qh_new();
void qh_ascnew();
void qh_strnew();
void qh_sttnew();
void qh_typeof();
void qh_atypeof();
void qh_dimension();
void qh_arraysize();
void qh_exit();
void qh_argv();
void qh_system();
void qh_sleep();
void qh_rand();
void qh_srand();
void qh_time();
void qh_clock();
void qh_expand_cell_space();
void qh_clear();
void qh_clone();
void qh_equal();
void qh_strcpy();
void qh_strncpy();
void qh_strcat();
void qh_strcmp();
void qh_strncmp();
void qh_strlen();
void qh_strdup();
void qh_chop();
void qh_bswrite();
void qh_swrite();
void qh_eswrite();
void qh_atoi();
void qh_ator();
void qh_atoc();
void qh_gopen();
void qh_gclose();
void qh_gwindow();
void qh_gscreen();
void qh_gcopy();
void qh_gcopy_area();
void qh_gbacking_store();
void qh_gsync();
void qh_gclear();
void qh_gtitle_name();
void qh_gicon_name();
void qh_gflush();
void qh_gtext_width();
void qh_gtext_height();
void qh_gpoint();
void qh_gbell();
void qh_gline();
void qh_gline2();
void qh_gpset();
void qh_gbox();
void qh_gfbox();
void qh_gpoly();
void qh_gfpoly();
void qh_gcircle();
void qh_gfcircle();
void qh_garc();
void qh_gfarc();
void qh_gstring();
void qh_gspline();
void qh_gfspline();
void qh_gfont();
void qh_gjfont();
void qh_glookup_color();
void qh_gsetdash();
void qh_gcolor_name();
void qh_gcolor_rgb();
void qh_gcolor_fg();
void qh_gpen();
void qh_gpen3();
void qh_gbutton();
void qh_gkey();
void qh_gpause();
void qh_gpause1();
void qh_gpointer();
void qh_gpixel_per_mmx();
void qh_gpixel_per_mmy();
void qh_gdisplay_width();
void qh_gdisplay_height();
void qh_gresize_screen();
void qh_gselect_input();
void qh_gvisualize_screen();
void qh_xfopen();
void qh_xfclose();
void qh_xfwrite2();
void qh_xfwrite3();
void qh_xfread();
void qh_xfgetc();
void qh_xfputc();
void qh_xftrunc();
void qh_xfseek();
void qh_xpopen();
void qh_xfcreate();
void qh_xfdelete();
void qh_car();
void qh_cdr();
void qh_cons();
void qh_rplaca();
void qh_rplacd();
#endif
