/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___FUNCTION_H_
#define ___FUNCTION_H_

#include "qhobj.h"

#define DEFAULT_MAX_NUMBER_OF_FUNCTIONS 256
#define FUNCTAB(entry) (func_table[entry])

enum function_state
{
    F_Undefined,		/* undefined yet */
    F_Defined			/* already defined */
};

typedef struct _Function
{
    int name;			/* function name */
    int module;			/* module name */
    int addr;			/* address */
    int align;			/* address to MemFunction */
    short narg;			/* number of function arguments */
    short state;		/* see function_state */
    short offsp;		/* offset of stack pointer */
    char load_flag;		/* already loading */
    char loadfn;		/* must load function */
    char extern_function;	/* is extern function */
    QuadList body;		/* body */
} Function;

typedef struct _MemFunction
{
    int   addr;			/* absolute address of function entrance */
    char* name;			/* function name */
    char* module_name;		/* module name */
    short narg;			/* number of arguments */
    short offsp;		/* incremental SP */
    void (*extern_function)();	/* nonnil if extern function */
} MemFunction;

void init_functab(void);
void free_funcquad(void);
void free_functab(void);

extern Function* func_table;	/* function table */
extern int ndef_func;		/* number of defined function  */
extern int nmemfunc;
extern MemFunction* memfunctab;	/* information for calling a function */

int add_new_function(int narg, int name, int module);
/* add new function entry, and returns it */

Bool define_function(int func);
/* if already function is defined, returns False,
 * else returns True
 */

void must_load_function(long name, long module, int narg);
/* it will load in compile */

void declare_extern_function(int name);
/* declare extern function
 * `compile_flag' bust be True.
 */


#endif /* ___FUNCTION_H_ */
