/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X10.h>
#include "common.h"
#include "gutil.h"

/* XDraw(Display* disp, Drawable drawable, GC gc, Vertex* vlist, int vcount); */
/* XDrawFilled(Display* disp, Drawable drawable, GC gc, Vertex* vlist, int vcount); */

void draw_gspline(Display* disp, Drawable win, GC gc, XPoint* p, int np)
{
    Vertex* vlist;
    int i;

    if(np < 4)
	return;			/* np must be more than 4 */

    vlist = (Vertex *)xmalloc(sizeof(Vertex) * np);
    for(i = 0; i < np; i++)
    {
	vlist[i].x     = p[i].x;
	vlist[i].y     = p[i].y;
	vlist[i].flags = VertexCurved;
    }

    vlist[0   ].flags = VertexDontDraw | VertexCurved;
    vlist[1   ].flags = VertexDontDraw | VertexCurved;
    vlist[np-1].flags = VertexDontDraw;

    XDraw(disp, win, gc, vlist, np);

    xfree(vlist);
}

void draw_gfspline(Display* disp, Drawable win, GC gc, XPoint* p, int np)
{
    int i;
    Vertex* vlist;

    if(np < 3)
	return;			/* np must be more than 3 */

    vlist = (Vertex *)xmalloc(sizeof(Vertex) * (np + 1));
    for(i = 0; i < np; i++)
    {
	vlist[i].x     = p[i].x;
	vlist[i].y     = p[i].y;
	vlist[i].flags = VertexCurved;
    }

    vlist[0].flags = VertexStartClosed | VertexCurved;
    vlist[i].flags = VertexEndClosed | VertexCurved;
    vlist[i].x     = vlist[0].x;
    vlist[i].y     = vlist[0].y;

    XDrawFilled(disp, win, gc, vlist, np + 1);

    xfree(vlist);
}
