/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___GUTIL_H_
#define ___GUTIL_H_

#define FONTHEIGHT(fs)  ((fs)->max_bounds.ascent + (fs)->max_bounds.descent)

/* allocate color              defined in color.c */
int RGB(Display *disp, int r, int g, int b);
int MyColor(Display* disp, const char* color);

/* whether backing store use or not */
void set_backing_store(Display* disp, Window w, Bool use);

/* obtain ascii code in KeyPress event */
int glookup_char(XKeyEvent* e);

/* load font */
XFontStruct *gload_query_font(Display* disp, const char* name);

/* text width */
int gmb_text_width(XFontStruct* fs1, XFontStruct* fs2,
		   unsigned const char* string);

/* draw font */
void gmb_draw_string(Display* disp, Drawable win, GC gc,
		     XFontStruct* fs1,
		     XFontStruct* fs2,
		     int x, int y,
		     unsigned const char* string);

/* query mouse pointer */
void gget_pointer(Display* disp, Window win, int* x, int* y);


/* get event mask */
unsigned long gget_event_mask(Display* disp, Window win);

/* draw spline curve */
void draw_gspline(Display* disp, Drawable win, GC gc, XPoint* p, int np);

/* draw filld spline curve */
void draw_gfspline(Display* disp, Drawable win, GC gc, XPoint* p, int np);

Bool gsleep_event(Display* disp, XEvent* e, double t);
/* limit time: t */

void gmake_bitpattern_dash(unsigned long pattern, /* Must not be all 0 or 1. */
			   int *start_offset_return,
			   char dash_list_return[/* 32 */],
			   int* nelem_return);

#endif /* ___GUTIL_H_ */
