/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___INTERP_H_
#define ___INTERP_H_

#include "QHFunc.defs"
#include "QHFuncStack.h"
#include "qhobj.h"
#include "array.h"
#include "assoc.h"
#include "qhstring.h"
#include "qhstruct.h"
#include "qhlist.h"

typedef struct _QHProg
{
    long op;			/* oparation code */
    long res;			/* result address */
    long a1;			/* argument address 1 */
    long a2;			/* argument address 2 */
} QHProg;

typedef struct _QHProgTraceInfo
{
    unsigned short fname_entry;	/* hash table entry of program source file */
    unsigned short lineno;	/* line number of source file */
} QHProgTraceInfo;

#define MEMADDR(a) ((a) < 0 ? qh_sp + (a) : (a))
#define MEMSTACK_SIZE 1024

void init_interp(void);
/* initialize interpreter */

void interp(QHProg* p);
/* interpret a program */

void qh_restore(void);
/* restore */

/* error in execution */
void execute_error(const char* errmsg);
void invalid_operation(int op);

extern int qh_pc;		/* program counter */
extern int qh_sp;		/* stack pointer */
extern int qh_top;		/* top stack pointer */
extern QHFuncStack fstk;	/* function stack */
extern intStack istack;		/* integer stack for IPUSH, ipop */
extern QHProg* qhprog;
extern QHProgTraceInfo* qhprog_traceinfo;
void next_qhprog(Quad2* q, QHTextPos* tp);
int get_current_qhprog(void);

void print_qhprog(void);

/* for debug */
void print_memstack1(QHObj* x);

/* object to string */
char* obj_string(char* buff, QHObj* x);

void extern_unload_function(int argc, QHObj* argv, QHObj* ret);
/* default extern function entry */

#include "builtin.h"

#endif /* ___INTERP_H_ */
