/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___ISOPDEFS_H_
#define ___ISOPDEFS_H_

#define IS_2OP(op) BETWEEN(ADD, op, GT)
/* op: ADD SUB MUL DIV REM ATAN2 LOGOR LOGAND LLSHIFT LRSHIFT ALSHIFT ARSHIFT POW EQ NQ LE LT GE GT */

#define IS_1OP(op) BETWEEN(SIN, op, SIZEOF_OP)
/* op: UMINUS ADDR INDIR LOGNOT NOT NOTNOT ZERO ONE SIZEOF_OP */

#define IS_BITOP(op) BETWEEN(LOGOR, op, ARSHIFT)
/* op: LOGOR LOGAND LLSHIFT LRSHIFT ALSHIFT ARSHIFT */

#define IS_ASSIGNOP(op) BETWEEN(AASSIGN, op, ASSIGN)
/* op: AASSIGN SASSIGN MASSIGN DASSIGN RASSIGN ASSIGN */

#define IS_RELOP(op) BETWEEN(EQ, op, GT)
/* op: EQ NQ LE LT GE GT */

#define IS_INCDECOP(op) BETWEEN(XINC, op, DECX)
/* op: XINC INCX XDEC DECX */

#define IS_GOTOOP(op) BETWEEN(IFGOTO, op, GOTO)
/* op: IFGOTO IFNGOTO IFEQGOTO IFNQGOTO IFLEGOTO IFLTGOTO IFGEGOTO IFGTGOTO GOTO */

#define IS_RELGOTOOP(op) BETWEEN(IFEQGOTO, op, IFGTGOTO)
/* op: IFEQGOTO IFNQGOTO IFLEGOTO IFLTGOTO IFGEGOTO IFGTGOTO */

#define IS_ARRAYOP(op) (BETWEEN(AREF, op, ASET) || BETWEEN(AXINC, op, ADECX))
/* op: AREF AASET ASSET AMSET ADSET ARSET ASET
       AXINC AINCX AXDEC ADECX */

#define CAN_CHANGE_RESULT_ADDR_OP(op) \
    (IS_2OP(op)        || \
     IS_1OP(op)        || \
     IS_INCDECOP(op)   || \
     ((op) == CALL)    || \
     ((op) == FUNCALL) || \
     ((op) == LIST_OP) || \
     ((op) == STREF))


#endif /* ___ISOPDEFS_H_ */
