#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "qhobj.h"

static char* key_to_string[QH_NKeyWord] =
{
    "NULL",
};


Tree* gen_keyword_node(long name)
{
    Tree* node;
    static long Q_NULL = -1;

    if(Q_NULL < 0)
    {
	Q_NULL = install_string("_NULL");
    }

    node = alloc_tree();
    node->type = T_QHKEYWORD;

    if(name == Q_NULL)
    {
	node->val = QH_Key_Null;
    }
    else
    {
	sprintf(temp_buff, "Unkndown keyword: `%s'", STRING(name));
	yyerror(temp_buff);
    }
    return node;
}

char* qhkeyword_string(int key)
{
    if(key < 0 ||
       key >= QH_NKeyWord)
    {
	fprintf(stderr, "Systematic error: Invalid keyword code: %d\n", key);
	exit(1);
    }

    return key_to_string[key];
}
