/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "newtemp.h"
#include "intStack.h"

#define IS_TEMP(name) (STRING(name) != NULL && (STRING(name)[0] == temp_prefix))

const int  temp_prefix = '$';
intStack   tbuf;
static int temp_cnt;

void init_temp(void)
{
    makeintStack(&tbuf, 256);
    temp_cnt = 0;
}

void free_temp(void)
{
    deleteintStack(&tbuf);
}

int newtemp(void)
{
    int tname;

    if(isemptyintStack(&tbuf))
    {
	sprintf(temp_buff, "%c%d", temp_prefix, temp_cnt++);
	tname = install_string(temp_buff);
#ifdef CHECK_NEWTEMP
	printf("newtemp %s\n", temp_buff);
#endif
    }
    else
    {
	tname = popintStack(&tbuf);
    }

#ifdef CHECK_NEWTEMP
    write_newtemp_stack();
#endif

    return tname;
}

void reuse_temp(int name)
{
    pushintStack(&tbuf, name);
#ifdef CHECK_NEWTEMP
    write_newtemp_stack();
#endif
}

void reuse_if_temp_sym(Symbol* sym)
{
    if(IS_TEMP_SYM(sym))
	reuse_temp(sym->name);
}

#ifdef CHECK_NEWTEMP
void write_newtemp_stack(void)
{
    int i;

    printf("newtemp-buffer:[ ");
    for(i = 0; i < tbuf.ptr; i++)
	printf("%s ", STRING(tbuf.elem[i]));
    printf("]\n");
}
#endif
