#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "dld.h"

struct objlist
{
    void* handler;
    char* name;
    struct stat st;
    struct objlist* next;
};

static struct objlist* objlist = NULL;

void dld_init(const char* prog) { /* Do nothing */ }

void dld_link(const char* obj)
{
    struct objlist *ptr;
    struct stat s;

    if(stat(obj, &s) < 0)
    {
	perror(obj);
	exit(1);
    }

    for(ptr = objlist; ptr; ptr = ptr->next)
    {
	if(s.st_ino == ptr->st.st_ino && s.st_dev == ptr->st.st_dev)
	    return; /* all ready linked */
    }

    if((ptr = (struct objlist *)malloc(sizeof(struct objlist))) == NULL)
    {
	perror("malloc");
	exit(1);
    }

    if((ptr->handler = dlopen(obj, RTLD_LAZY)) == NULL)
    {
	perror(obj);
	exit(1);
    }

    ptr->name = strdup(obj);
    ptr->st = s;
    ptr->next = objlist;
    objlist = ptr;
}
    
void* dld_get_func(const char* name)
{
    struct objlist *ptr;
    void* f;

    if(objlist == NULL)
	return NULL;
    for(ptr = objlist; ptr; ptr = ptr->next)
	if((f = dlsym(ptr->handler, name)) != NULL)
	    return f;
    return NULL;
}
