/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___STMT_H_
#define ___STMT_H_

#define GOTONODE(label) gen_quad_node1(GOTO, label, NULL, NULL)

void init_stmt(void);
void free_stmt(void);

int newlabel(void);

QuadList gen_goto_stmt(long name, long module);
QuadList gen_label_stmt(long name, long module);
QuadList gen_return_stmt(Tree* expr);
void     while_head_stmt(void);
QuadList while_tail_stmt(Tree* expr, QuadList* body);
QuadList gen_if_stmt(Tree* expr, QuadList* if_body);
QuadList gen_if_else_stmt(Tree* expr, QuadList* if_body, QuadList* else_body);
void     for_head_stmt(void);
QuadList for_tail_stmt(Tree* expr1, Tree* expr2, Tree* expr3, QuadList* body);
QuadList gen_break_stmt(void);
QuadList gen_continue_stmt(void);
void     gen_do_while_head_stmt(void);
QuadList gen_do_while_tail_stmt(Tree* expr, QuadList* body);

/* switch-case */
void     switch_head(Tree* t);
QuadList new_switch_case_label(Tree* t);
QuadList new_switch_default_label(void);
QuadList gen_switch_stmt(QuadList* q);

/* enum */
void start_enumerate(void);
void define_enumerate(long name, Tree* t);

QuadList gen_write_stmt(Tree* param, int narg, Bool newline);
QuadList gen_swrite_stmt(Tree* param, int narg);

/* bstack: for `break' statement */
/* cstack: for `continue' statement */

#define MAX_STMT_NEST 16

void push_bstack(int val);
void push_cstack(int val);

int top_bstack(void);
int top_cstack(void);

int pop_bstack(void);
int pop_cstack(void);

void pragma_option(const char* opt, const char* val);

#endif /* ___STMT_H_ */
