/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

#define MAX_TEXT_FILE_NO 257
#define FILE_NAME_TABLE(addr) text_file_name_teble[addr]

struct text_file_name_teble_t
{
    long id;
    char* name;
};

static struct text_file_name_teble_t text_file_name_teble[MAX_TEXT_FILE_NO];

unsigned short install_text_filename(long id, const char* str)
{
    unsigned short i, addr;
    static int init_flag = False;

    if(init_flag == False)
    {
	init_flag = True;
	for(i = 0; i < MAX_TEXT_FILE_NO; i++)
	{
	    FILE_NAME_TABLE(i).id = 0;
	    FILE_NAME_TABLE(i).name = "";
	}
    }

    if(id == 0)
	return 0;

    addr = id % MAX_TEXT_FILE_NO;

    for(i = 0; i < MAX_TEXT_FILE_NO; i++)
    {
        if(FILE_NAME_TABLE(addr).id == 0)
        {
            FILE_NAME_TABLE(addr).id = id;
	    FILE_NAME_TABLE(addr).name = strdup(str);
            return addr;
        }
        if(FILE_NAME_TABLE(addr).id == id)
            return addr;
        addr = (addr + 1) % MAX_TEXT_FILE_NO;
    }

    fprintf(stderr, "Too many file open.\n");
    fprintf(stderr, "Please redefine `MAX_TEXT_FILE_NO' in `textpos.c', and recompile this program.\n");
    qhexit(1);

    return 0;                   /* dmy */
}

char* text_file_entry_to_string(unsigned short entry)
{
    return FILE_NAME_TABLE(entry).name;
}
