#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>		/* for sysconf () */
#include <sys/times.h>		/* for times */
#include "timer.h"

double get_current_calender_time(void)
{
    struct timeval tv;

    /*
     * SVR4 has gettimeofday() without timezone
     */
#ifdef SVR4
    gettimeofday(&tv);
#else
    gettimeofday(&tv, NULL);
#endif

    return (double)tv.tv_sec + (double)tv.tv_usec / 1000000.0 ;
}

static struct tms old_time;
static int clock_tick = 0;

void set_laptime(void)		/* initialize laptime */
{
    times(&old_time);
}

double get_laptime(void)
{
    struct tms new_time;

    if (clock_tick == 0) {
	clock_tick = sysconf(_SC_CLK_TCK);
    }
    times(&new_time);

    return (double)(new_time.tms_utime - old_time.tms_utime) /
      (double)clock_tick;

}
